# Displaying certain properties
Get-Service | Format-Table Name, Status

# Change Column Headings
$cols = @{Label="KB"; Expression = { [int]($_.Length/1KB) } }
Get-ChildItem | Format-Table Name, $cols
# The above hash table feeds into a format that the Format Table cmdlet will accept.  
# The hash table is made up of two fields; `Label` and `Expression`.  
# Of note, `Expression` is a script block, and will place its resulting output on the field designated by `Label`.  
# As `Format-Table` will process objects off the pipeline, it can interact with the `$_` automatic variable.  
----
Source: https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.utility/format-table?view=powershell-5.1
----


# Grouping using formatting cmdlets
# Group by extension
Get-ChildItem | Sort-Object -Property Extension | Format-Table -GroupBy Extension
