﻿# Sorted output
Get-ChildItem | Sort-Object

# Sorted by file size
Get-ChildItem | Sort-Object -Property Length -Descending

# Grouped output
Get-Service | Group-Object Status

# Group by extension and sorted by count descending
Get-ChildItem | Group-Object Extension | Sort-Object Count -Descending

# Grouping expressions
Get-ChildItem | Group-Object {$_.Length -lt 1KB}

# Alphabetically grouped results
Get-Process | Group-Object {$_.Name.Substring(0,1).ToUpper()} | ForEach-Object{($_.Name + " ") *7; "=========="; $_.Group}

# Sorted and grouped
Get-ChildItem | Sort-Object Extension, Name | Format-Table -GroupBy Extension

# Sorting specific types
1, 7, 10, 8, 2, 3 | Sort-Object
'1', '7', '10', '8', '2', '3' | Sort-Object

# Using type conversion with Sort-Object
'1', '7', '10', '8', '2', '3' | Sort-Object -Property { [Int]$_ }

# Produce random sorting with Sort-Object
1..10 | Sort-Object -Property { Get-Random }

# View PowerShell automatic variable descriptions
Get-Variable | Sort-Object Name | Format-Table Name, Description -AutoSize -Wrap

