﻿# Using Where-Object to return only the services with the status of running
Get-Service | Where-Object {$_.Status -eq "Running"}

# Filter processes using Where-Object and Sort-Object
Get-Process | Where-Object {$_.Name -notlike 'powershell*'} | Sort-Object id -Descending

# Using Select-Object to list top 10 processes
Get-Process | Select-Object -First 10

# List 10 longest-running processes
Get-Process | Sort-Object StartTime | Select-Object -Last 10 | Format-Table ProcessName, StartTime