﻿# Example 1 function with mandatory parameters
function test-me {
    param (
        [Parameter(Mandatory=$true)]
        $var
    )
    "Your name is $var"
}

# Example 2 function with help message
function test-message {
    param (
        [Parameter(Mandatory=$true, HelpMessage='Enter a name please')]
        $var
    )
    "Your name is $var"
}


# Example 3 strongly typed mandatory parameters
﻿function Convert-ToDollars {
    param(
        [Parameter(Mandatory, HelpMessage='Enter number of Euros.')]
        [Double]
        $Euro
    )
    
    $Dollar = $Euro * 1.4
    $Dollar
}