﻿Function Set-IPRange {
    param(
        [Parameter(Mandatory, Position=0)]
        $startip,
        [Parameter(Mandatory,Position=1)]
        $endip
    )
    $ip1 = ([ipaddress]$startip).GetAddressBytes()
    [array]::Reverse($ip1)
    $ip1 = ([ipaddress]($ip1 -join '.')).Address

    $ip2 = ([ipaddress]$endip).GetAddressBytes()
    [array]::Reverse($ip2)
    $ip2 = ([ipaddress]($ip2 -join '.')).Address
    
    for($x=$ip1;$x -le $ip2;$x++) {
        $ip = ([ipaddress]$x).GetAddressBytes()
        [array]::Reverse($ip)
        $ip -join '.'
    }
}




Function Get-IPRange {
    param(
        [Parameter(Mandatory,Position=0)]
        $network
    )
    $straddy = ($network.split('/'))[0]
    [int]$netlength = ($network.split('/'))[1]
    $netip = ([ipaddress]$straddy).GetAddressBytes()
    $iplen = (32 - $netlength)
    [array]::reverse($netip) 
    $numip = ([math]::pow(2, $iplen)) - 1
    $netip = ([ipaddress]($netip -join '.')).Address
    $start = $netip + 1
    $end = $netip + $numip
    if($end -isnot [Double]) {
        $end = $end -as [double]
    }
    if($start -isnot [double]) {
        $start = $start -as [double]
    }
    $start = ([ipaddress]$start).IPAddressToString
    $end = ([ipaddress]$end).IPAddressToString
    Set-IPRange $start $end
}