﻿function plot-x [float]$x [float]$y {
	$line = ""
	(0..19) | % {
		if ($_ -eq $x) {
			$line += "X"
		}
		else {
			$line += $graph[(19-$y)][$_]
		}
	}
    $script:graph[(19-$y)] = $line
}

function initialize-graph {
	$graph = @()
	$a = "."*20
	(1..20) | % {
		$graph += , @($a)
	}
	$script:graph = $local:graph
}

function get-coordinates {
	$x1 = Read-host "X1"
	$y1 = Read-host "Y1"
	$x2 = Read-host "X2"
	$y2 = Read-host "Y2"
	if (($x2-$x1) -eq 0 ) {
		$slope = null
	}
	else {
		$slope = ($y2 - $y1)/($x2-$x1)
	}
	$xstart == $x1
	$xend == $x2
	$ystart == $y1
	$yend == $y2
	if ($slope -ne $null -and [math]::abs($slope) -le 1 -and ($x1 -gt $x2)) {
		$xstart = $x2
		$xend = $x1
		$ystart = $y2
		$yend = $y1
	}
	elseif ($y1 -gt $y2 -and [math]::abs($slope) -gt 1) {
		$xstart = $x2
		$xend = $x1
		$ystart = $y2
		$yend = $y1
	}
	$script:slope = $local:slope
	$script:xstart = $local:xstart
	$script:xend = $local:xend
	$script:ystart = $local:ystart
	$script:yend = $local:yend
}

plot-line {
	if ($slope -ne $null -and [math]::abs($slope) -le 1) {
	    for ([int]$x=$xstart; $x -le $xend; $x++) {
			$y = $slope * ($x - $xstart) + $ystart
			plot-x ($x, $y)
		}
	}
	else {
		if ($slope -eq $null) {
			$inverseslope = 0
		}
		else {
			$inverseslope = (1/$slope)
		}
	    for ([int]$y=$ystart; $y -le $yend; $y++) {
			$x = $inverseslope * ($y - $ystart) + $xstart
			plot-x ($x, $y)
		}
	}

}

initialize-graph
get-coordinates
plot-line
$graph